package server;
import java.util.ArrayList;
import java.util.Iterator;
import java.net.*;
import java.io.*;


//implementace serveru
public class Server implements Runnable
{
  private int port;
  private ArrayList <Writer> writer;
  private Thread thread;
  private int id = 0;               //pocet klientu
  private final int writerCount = 20;//zacateny pocet 

  //konstriktor-> inicialicace portu, vytvoreni Threadu, vytvoreni seznamu uzivatelu ( klientu ) a
  //spusteni serveru ( threadu )
  public Server( int port )
  {
    this.port = port;
    thread    = new Thread(this);
    writer    = new ArrayList( writerCount );
    thread.start();
  }
  
  public void run()
  {
    //incializace
    ServerSocket server = null;
    boolean run         = true;
    
    try
    {
      server = new ServerSocket ( port );  //vytvorit socket pro server na danem portu
      System.out.println("[Server] listening at "+port);
      
      while( run )
      {
        Socket client = null;
        client = server.accept();//posloucham dokud se klient nepripoji
        writer.add( new Writer( client, ++id ) );//vytvor Writer->ktery se postara o pripojeneho klienta
        System.out.println("[Server] Client number "+ id + " has been connected.");
        if (thread.interrupted()) //pokud byl thread prerusen skonci
          run = false;
      }
    }
    catch( Exception e )
    {
      System.out.println("[Server] Error "+ e.getMessage());
    }
    finally 
    {
        for (Iterator<Writer> i = writer.iterator(); i.hasNext(); ) 
        {
          i.next().kill();
          i.remove();
        }
        try 
        {
            if (server != null)
              server.close() ;
        } 
        catch (Exception e) 
        {
             System.out.println("[Server ]Can't close server socket." + e.getMessage());
        }
    }
  }
}
