
package server;

//rozdelit transfer na read a write, spise zdedit z predka spolecneho

import java.io.*;
/**

 * Tato trida se stara o praci s daty ktere chceme prijimat ci odesilat
 **/

public class TransferWriter extends TransferBase
{
    private BufferedOutputStream    outStream;
    
    public TransferWriter( String fileName, long size ) 
    {
        super( fileName, size );
        try 
        {
            if(file.exists())//pokud soubor na serveru existuje, smaz ho
              file.delete();
            
            file.createNewFile();//a vytvor novy
            outStream = new BufferedOutputStream ( new FileOutputStream( file ));
        } 
        catch (Exception e ) 
        {
            System.out.println("[TransferWriter] Error "+ e.getMessage());
        }
    }
    
    public void Close()//zavri soubor
    {
      try 
      {
        if( outStream != null )
        {
         outStream.flush();
         outStream.close();
        }
      }
      catch(IOException e)
      {
        System.out.println("[TransferWriter] Error "+e.getMessage());
      }
    }
    
    public void Write( byte[] block, int size ) 
    {
        try 
        {
          if( act+size > length )//pokud jsme dosahli konce uprav delku dat pro zapis do souboru
            size = (int)(length - act);
         
          act += size;
          outStream.write(block,0,size);//uloz do souboru data
            
            if( act > GetSize() )
            {
                outStream.flush();
                outStream.close();//zavri a uloz soubor
                this.state = states.FINISH;
            }
        } 
        catch (Exception e) 
        {
            System.out.println("[TransferWriter] Error "+e.getMessage());
        }
    }
    
}
