
package server;
import java.util.*;
import java.net.*;
import java.io.*;


public class Writer implements Runnable
{
  private Thread thread;
  private Socket socket;
  int id;
  
  public Writer( Socket socket, int id )
  {
    this.id     = id;
    this.socket = socket;
    thread      = new Thread(this);//vytvoreni threadu ( vlakna )
    thread.start();//start vlakna
  }
  
  public void run()
  {
    //inicializace promennych
    BufferedReader read   = null;
    BufferedWriter write  = null;
    boolean data          = false;
    
    byte byty[] = new byte[128];
    long datasize = 0;
    String filename = null;
    TransferWriter file = null;
    boolean run = true;

    
    try
    {      
      read  = new BufferedReader(new InputStreamReader ( socket.getInputStream()));
      write  = new BufferedWriter(new OutputStreamWriter(socket.getOutputStream()));
       
      while( run )//nase nekonecna smycka :-)
      {
        
        if(!data)
        {
          String input = read.readLine();//ctu dokud mi client neodesle jmeno a velikost prenaseneho souboru

          if( !input.isEmpty() )
          {
            int position = input.indexOf("-");//je to rozdelene pomoci "-" a to napr. soubor.txt-323 
            if( position > 0 )//pokud je nalezena pomlcka
            {
                filename = input.substring(0,position);
                datasize   = Long.parseLong( input.substring(position+1) );
                write.write("OK\r\n");//odesli clientovi ze muze zacit posilat soubor
                write.flush();
                file = new TransferWriter(filename,datasize);//vyvor instanci pro zapisovani do souboru
                System.out.println("[Writer"+id+"] Received transmission ."+ filename+" "+datasize +" B.");
                data = true;
            }
          }
        }
        else if( file != null )
        {
          int size = 0;          
          try 
          {
           // while(run)
            {
              if( (size = socket.getInputStream().read(byty)) != -1)  //cti prichozi data dokud neni konec(-1)
              {
                  System.out.println("[Writer"+id+"] Send data "+ size +" B.");
                  file.Write(byty, size);//zapisuj do souboru
              }
              else
              {
                file.Close();//zavri soubor
                System.out.println("[Writer"+id+"] written "+ file.GetActSize());
                run = false;//ukonci vlakno
              }
            }
          } 
          catch (SocketTimeoutException e) 
          {
            System.out.println("[Writer"+id+"] Socket timeout2 "+ e.getMessage());
            continue;   
          }
        }
        else
        {
          System.out.println("[Writer"+id+"] Unexpected error.");
        }
      
      }
    }
    catch( Exception e )
    {
      System.out.println("[Writer"+id+"] Error "+e.getMessage());
    }
    finally 
    {
      try
      {
      if(read != null) read.close();
      if( socket!= null ) socket.close();
      if(write != null) write.close();
      }
      catch( IOException e )
      {
        System.out.println("[Writer"+id+"] Error socket close "+e.getMessage());
      }
    }
    
    System.out.println("[Writer"+id+"] Exit");
  }
  
  public void kill()//killnuti vlakna
  {
    thread.interrupt();
  }
  
}
